/* FILE_ID.DIZ READER - by Jerry McBride */

    '@cls'
    say''
    say'FID.CMD version 3.0 - A file list creator'
    say''

    archiveloop=0
    archivefilesize=0
    targetdirectory=''
    destinationdirectory=''
    filelist=''
    arg=''
    test=0
    filecount=0
    filesize=0

    arg commandline

    parse upper arg targetdirectory destinationdirectory filelist

    if targetdirectory='' then test=test+1

    if destinationdirectory='' then test=test+1

    if filelist='' then test=test+1

errors:

    if test>0 then do
            say'The correct FID.CMD command line usage is:'
            say''
            say'FID.CMD TARGET DESTINATION FILENAME'
            say''
            say'TARGET = Where your archives are stored.'
            say'DESTINATION = Where you want your file list created.'
            say'FILENAME - The name of your new file list.'
            say''
            say'Example: FID.CMD c:\files e:\lists FILELIST.TXT'
            say''
            say'You entered: 'commandline
            exit
            end

/* load in REXXUTIL */

    call rxfuncadd 'SysLoadFuncs', 'REXXUTIL', 'SysLoadFuncs'
    call sysloadfuncs

    drivemap=sysdrivemap('a:','USED')

    targetdrive = substr(targetdirectory, 1, 2)

/* test target drive */

    IF pos(targetdrive,drivemap)=0 THEN DO
            say'You must specify a DRIVE: in the TARGET parameter.'
            say''
            test=1
            signal errors
            end

/* test target directory */

    rc=sysfiletree(targetdirectory, dirs ,'D', '*****')

    if dirs.0=0 then do
            say 'Target directory dose not exist!'
            test=1
            signal errors
            END

    destinationdrive = substr(destinationdirectory, 1, 2)

/* test destination drive */

    IF pos(destinationdrive,drivemap)=0 THEN DO
            say'You must specify a DRIVE: in the DESTINATION parameter.'
            test=1
            signal errors
            end

/* test destination directory */

    rc=sysfiletree(destinationdirectory, dirs ,'D', '*****')

    if dirs.0=0 then do
            say 'Destination directory dose not exist!'
            test=1
            signal errors
            END

    starttime=time()

    say 'Reading FILE_ID.DIZ files and building list.'

    file_list=''
    dir_list=''

    call sysfiletree targetdirectory||'\*', archive ,'FS', '*****'

again:

    archiveloop = archiveloop + 1

    if archiveloop > archive.0 then signal alldone

    filecount=filecount+1

    parse var archive.filecount archivefiledate archivefiletime archivefilesize archivefileattribs archivefilename f g h

    filesize = filesize + archivefilesize

    call stream archivefilename, 'c', 'open read'

    select
       when charin(archivefilename,1,4) == x2c(504b0304) then t='unzip -Co '
       when charin(archivefilename,3,5) == "-lh5-"       then t='lh x /o '
       when charin(archivefilename,1,4) == "Rar!"        then t='rar e '
       when charin(archivefilename,1,1) == x2c(1a)       then t='arc2 xo '
       when charin(archivefilename,1,2) == x2c(60ea)     then t='unarj e '
    otherwise
       t=''
    end

    call stream archivefilename, 'c', 'close'

    '@del '||'file_id.diz 1>nul 2>nul'

    if t<>'' then '@'||t||archivefilename||' file_id.diz 1>nul 2>nul'

    say'Processed : '||archivefilename

    text='No Description available!'
    linecount=1
    line.1=text

    call sysfiletree 'file_id.diz', file ,'F', '*****'

    if file.0 > 0 then do

            index = 1

            Do While Lines('file_id.diz')=1
                    list.index = strip(LineIn('file_id.diz'))
                    index = index + 1
                    End

            call stream 'file_id.diz', 'c', 'close'

            text=''

            do ii = 1 to index - 1
            text=text||list.ii||" "
            end

    end

/* strip out all graphic codes */

    newtext=''

    do ii = 1 to length(text)

    char=c2d(substr(text,ii,1))

    if char < 122 then newtext=newtext||d2c(char)

    end

    text=newtext

/* strip out multiple spaces */

    newtext=''

    do ii = 1 to length(text)

    chars=substr(text,ii,1)

    if chars<>' ' then switch=0

    if switch=0 then newtext=newtext||chars

    if chars=' ' & switch=0 then switch=1

    end

    text=newtext

    if length of text > 45 then do

    linecount=1
    start=1
    stepsize=48
    step=stepsize
    loop=0

parseitagain:

    char=c2d(substr(text,step+start,1))

    if char > 32 then do
            step = step - 1
            signal parseitagain
            end

    line.linecount=strip(substr(text, start, step))

    if line.linecount<>'' then do
            linecount=linecount+1
            start = start + step
            step  = stepsize
            signal parseitagain
            end

done:

    temp=reverse(archivefilename)
    slash=pos('\',temp)
    temp=left(temp,slash-1)
    archivefilename=reverse(temp)

    ee=''
    do ii = 1 to 12 - length(archivefilename)
    ee=ee||' '
    end

    cc=''
    do ii = 1 to 8 - length(archivefilesize)
    cc=cc||' '
    end

    aa=''
    do ii = 1 to 9 - length(archivefiledate)
    aa=aa||' '
    end

    call lineout destinationdirectory||'\'||filelist,archivefilename||ee||cc||archivefilesize||aa||archivefiledate||' 'line.1

    do ii = 2 to linecount-1
    call lineout destinationdirectory||'\'||filelist,'                              '||line.ii
    end

    call stream  destinationdirectory||'\'||filelist, 'c', 'close'

    signal again

alldone:

    say''
    say'Process started at '||starttime||' and finished at '||time()

    '@del '||destinationdirectory||'\file_id.diz 1>nul 2>nul'

    call lineout destinationdirectory||'\'||filelist,'Total number of archives in this scan is: 'filecount
    call lineout destinationdirectory||'\'||filelist,'Total number of bytes in this scan is:  'filesize
    call stream  destinationdirectory||'\'||filelist, 'c', 'close'

    exit
